#ifndef __CPUHWINFO_H__
#define __CPUHWINFO_H__

#ifdef __cplusplus //__cplusplus
extern "C" {       /* assume C declarations for C++ */
#endif

/* cache(s) description */
typedef struct cpu_cache
{
    char *name;
    char *size;
} cpu_cache_t;

typedef struct _us_cpu_info
{
    char *arch;               //架构
    char *opmode;             //运行模式
    char *temp;               //cpu温度
    int ncpus;                //cpu的逻辑个数，
    int nsocket;              //cpu物理座的个数
    int ncores;               //核数
    int nthreads;             //线程数
    char *vendor;             //厂商
    char *family;             //系列
    char *model;              //型号
    char *modelname;          //型号名字
    char *stepping;           //步进
    char *mhz;                //当前频率
    char *maxmhz;             //最大频率
    char *minmhz;             //最小频率
    char *bogomips;           //运算速度
    char *virtflag;           //虚拟化
    int ncaches;              //缓存数量
    struct cpu_cache *caches; //缓存
    char *flags;              //指令集
} us_cpu_info_t;

#define IN
#define OUT

int us_get_cpu_total_info(OUT us_cpu_info_t **cpu_info);
int us_get_cpu_arch(OUT unsigned char *cpuArch, OUT unsigned short *len);
int us_get_cpu_vendor(OUT unsigned char *cpuVendor, OUT unsigned short *len);
int us_get_cpu_model(OUT unsigned char *cpuModel, OUT unsigned short *len);
int us_get_cpu_curTemp(OUT unsigned char *curTemp, OUT unsigned short *len);
int us_get_cpu_freq(OUT unsigned char *cpuFreq, OUT unsigned short *len);
int us_get_cpu_cores(int *counter);
int us_get_cpu_virtual(unsigned short *cpuVirtual);
int us_get_cpu_threads(int *counter);
int us_free_cpu_total_info(us_cpu_info_t **cpu_info);

#ifdef __cplusplus
}
#endif

#endif //__CPUHWINFO_H__
